/// <reference types="mongoose" />
import * as mongoose from 'mongoose';
import { HttpRequest } from 'azure-functions-ts-essentials';
import { BaseDocument } from './models/base-document';
export { Activatable } from './models/activatable';
export { BaseDocument };
export declare function connect(instance: mongoose.Mongoose, connStr: string, timeout?: number, retry?: number): Promise<any>;
export declare function parseFields(rawFields: string): any;
export declare function parseQuery(rawQuery: string): any;
export declare function parsePopulation(rawPopulation: string): any;
export declare function parseSort(rawSort: string): any;
export declare function clearCollection(instance: mongoose.Mongoose, name: string): Promise<any>;
export declare class Mongooser<T extends BaseDocument> {
    private readonly model;
    constructor(model: any);
    getOne(id: any, projection?: any, population?: mongoose.ModelPopulateOptions | Array<mongoose.ModelPopulateOptions>): Promise<any>;
    getMany(criteria?: any, projection?: any, population?: mongoose.ModelPopulateOptions | Array<mongoose.ModelPopulateOptions>, page?: number, perPage?: number, sort?: string, showInactive?: boolean): Promise<any>;
    insertMany(req: HttpRequest): Promise<any>;
    updateOne(req: HttpRequest, id: any): Promise<any>;
    deactivateOne(id: any): Promise<any>;
}
